# ISingleComponentChooser Struct Reference
[COM Interfaces]

Inheritance diagram for ISingleComponentChooser:

List of all members.

## Public Member Functions
virtual void MCCOMAPI | Initialize (const IDType &inFamilyID, boolean inCanBeNone, boolean inShowFamilyName, IShParameterComponent *inComponent, boolean inShowToolBar=true)=0
virtual void MCCOMAPI | SetCanCollapse (boolean canCollapse)=0
virtual boolean MCCOMAPI | GetCanCollapse ()=0
virtual void MCCOMAPI | SetRefuseDrop (boolean refuseDrop)=0
virtual void MCCOMAPI | SetComponentUI (IShParameterComponent *inComponent)=0
virtual boolean MCCOMAPI | GetComponentUI (IShParameterComponent **outComponent)=0
virtual void MCCOMAPI | GetComponentsUI (TMCCountedPtrArray< IShParameterComponent > &outComponents)=0
virtual boolean MCCOMAPI | GetInternalComponentUI (IShParameterComponent **outComponent)=0
virtual boolean MCCOMAPI | GetOriginalComponentUI (IShParameterComponent **outComponent)=0
virtual IDType MCCOMAPI | GetFamilyID ()=0
virtual void MCCOMAPI | Filter (boolean(*filterCallBack)(IDType classSignature))=0
virtual void MCCOMAPI | SetSubPopupMode (boolean popupSubMode)=0
virtual void MCCOMAPI | SetSortMode (boolean popupSortMode)=0
virtual void MCCOMAPI | SetPopupIncludeMask (uint32 popupMaskInclude)=0
virtual void MCCOMAPI | SetPopupExcludeMask (uint32 popupMaskExclude)=0
virtual void MCCOMAPI | SetPopupVisible (boolean doShow)=0
virtual boolean MCCOMAPI | IsPopupVisible ()=0
virtual IMFCollapsiblePart *MCCOMAPI | GetCollapsiblePart ()=0

## Detailed Description

A single component chooser. For example, the Scene Effects components in the Effects list in Carrara. Allows the user to choose a component from a popup list of components in a given family. Displays the name of the current component in its UI part.

## Member Function Documentation

virtual void MCCOMAPI ISingleComponentChooser::Filter | ( | boolean(*)(IDType classSignature) | filterCallBack | ) | `[pure virtual]`

virtual boolean MCCOMAPI ISingleComponentChooser::GetCanCollapse | ( |  | ) | `[pure virtual]`

virtual IMFCollapsiblePart* MCCOMAPI ISingleComponentChooser::GetCollapsiblePart | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI ISingleComponentChooser::GetComponentsUI | ( | TMCCountedPtrArray< IShParameterComponent > & | outComponents | ) | `[pure virtual]`

Gets the components from the chooser. Clones the components. There are several components only in multivalue mode

Parameters:

  | outComponents | Returns a pointer to the cloned components

virtual boolean MCCOMAPI ISingleComponentChooser::GetComponentUI | ( | IShParameterComponent ** | outComponent | ) | `[pure virtual]`

Gets the component from the chooser. Clones the component.

Parameters:

  | outComponent | Returns a pointer to the component

virtual IDType MCCOMAPI ISingleComponentChooser::GetFamilyID | ( |  | ) | `[pure virtual]`

virtual boolean MCCOMAPI ISingleComponentChooser::GetInternalComponentUI | ( | IShParameterComponent ** | outComponent | ) | `[pure virtual]`

Gets the internal representation of the component for this chooser. Does not clone the component.

Parameters:

  | outComponent | Returns a pointer to the component.

virtual boolean MCCOMAPI ISingleComponentChooser::GetOriginalComponentUI | ( | IShParameterComponent ** | outComponent | ) | `[pure virtual]`

Gets the original representation of the component for this chooser. Does not clone the component. WARNING: do not use this function unless you really need what you do.

Parameters:

  | outComponent | Returns a pointer to the component.

virtual void MCCOMAPI ISingleComponentChooser::Initialize | ( | const IDType & | inFamilyID,
|  | boolean | inCanBeNone,
|  | boolean | inShowFamilyName,
|  | IShParameterComponent * | inComponent,
|  | boolean | inShowToolBar = `true` |
| ) |  |  | `[pure virtual]`

Initializes the component chooser.

Parameters:

  | inFamilyID | Family ID of components to make available for choosing
  | inCanBeNone | If true, having no component chosen is allowed
  | inShowFamilyName | If true, shows the family name in the UI
  | inComponent | Initial component to use. NULL to default to None.
  | inShowToolBar | Show the tool bar (open, save and preset buttons).

virtual boolean MCCOMAPI ISingleComponentChooser::IsPopupVisible | ( |  | ) | `[pure virtual]`

virtual void MCCOMAPI ISingleComponentChooser::SetCanCollapse | ( | boolean | canCollapse | ) | `[pure virtual]`

Hides or shows the collapse/expand arrow, to prevent user changing if desired.

Parameters:

  | canCollapse | If true, allows the user to collapse/expand the chooser contents

virtual void MCCOMAPI ISingleComponentChooser::SetComponentUI | ( | IShParameterComponent * | inComponent | ) | `[pure virtual]`

Sets the component for the chooser. Clones the component.

Parameters:

  | inComponent | Pointer to the component

virtual void MCCOMAPI ISingleComponentChooser::SetPopupExcludeMask | ( | uint32 | popupMaskExclude | ) | `[pure virtual]`

virtual void MCCOMAPI ISingleComponentChooser::SetPopupIncludeMask | ( | uint32 | popupMaskInclude | ) | `[pure virtual]`

virtual void MCCOMAPI ISingleComponentChooser::SetPopupVisible | ( | boolean | doShow | ) | `[pure virtual]`

virtual void MCCOMAPI ISingleComponentChooser::SetRefuseDrop | ( | boolean | refuseDrop | ) | `[pure virtual]`

Set if the chooser accept component drop.

virtual void MCCOMAPI ISingleComponentChooser::SetSortMode | ( | boolean | popupSortMode | ) | `[pure virtual]`

virtual void MCCOMAPI ISingleComponentChooser::SetSubPopupMode | ( | boolean | popupSubMode | ) | `[pure virtual]`

The documentation for this struct was generated from the following file:

- IComponentChooser.h